// MemoSendAttachList.cpp :  Դϴ.
//

#include "stdafx.h"
#include "CommonFunction.h"
#include "SendNoteMananger.h"
#include "MemoSendAttachList.h"
#include "SendMemoController.h"
#include "NoteModel.h"

// CMemoSendAttachList

IMPLEMENT_DYNAMIC(CMemoSendAttachList, CWnd)

CMemoSendAttachList::CMemoSendAttachList()
: m_pSendMemoController(NULL)
, m_pImgBG(NULL)
, m_pImgProgressFG(NULL)
, m_pImgFile(NULL)
, m_pImgCancel(NULL)
, m_pImgCancelOver(NULL)
, m_pImgInitMsg(NULL)
, m_strInitMsgText(L"")
, m_dwTotalSize(0)
, m_nScrollPageSize(0)
, m_bTracking(FALSE)
, m_bOnceFileSizeMsgBox(FALSE)
, m_bOnceFileCountMsgBox(FALSE)
,m_bEnbleCancel(TRUE)
, m_tridDelAttachedFile(0)
{

	ZeroMemory(m_pImgProgressBG,sizeof(m_pImgProgressBG));

	m_crBG = DEF_MEMOSEND_LIST_BG_COLOR;
	m_crOutline = DEF_MEMOSEND_LIST_BGOUTLINE_COLOR;

	// dimension
	m_rtWnd.SetRectEmpty();
	m_rtInitMsg.SetRectEmpty();
	m_rtInitMsgImg.SetRectEmpty();
	m_rtInitMsgText.SetRectEmpty();
	m_szInitMsgText.SetSize(0, 0);

	m_nScrollOneSize = DEF_MEMOSEND_LIST_SCROLL_SIZE;


	//g_pMessengerActor->RegisterObserver(this);
	g_pMessengerActor->GetWASActor()->RegisterObserver(this);	
    m_wszFontName[0] = _T('\0');
    m_nFontHeight = 0.0f;
    m_fontStyle = FontStyleRegular;
    m_rtScrollBar.SetRectEmpty();
    m_pSendMemoModel = NULL;
    ZeroMemory(&m_DeleteAttachFileInfo, sizeof(m_DeleteAttachFileInfo));
}

CMemoSendAttachList::~CMemoSendAttachList()
{

}

BEGIN_MESSAGE_MAP(CMemoSendAttachList, CWnd)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_ERASEBKGND()
	ON_WM_PAINT()
	ON_WM_MOUSEMOVE()
	ON_WM_MOUSEHOVER()
	ON_WM_MOUSELEAVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_SETCURSOR()
	ON_WM_SIZE()
	ON_WM_MOUSEWHEEL()
	ON_WM_KEYDOWN()
	ON_WM_VSCROLL()
	ON_MESSAGE(UM_MEMOSEND_FILEDROP,		OnUmMemoSendFileDrop)
	ON_MESSAGE(WM_MEMOSEND_INIT_FILEADD, OnInitFileAdd)
END_MESSAGE_MAP()

void CMemoSendAttachList::SetImgBGPath(CString strFileName)
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileName.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileName);

	m_pImgBG = new Image(strImgPath);
}

void CMemoSendAttachList::SetImgInitMsgPath(CString strFileName)
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileName.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileName);

	m_pImgInitMsg = new Image(strImgPath);
}

void CMemoSendAttachList::SetImgFilePath(CString strFileName)
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileName.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileName);

	m_pImgFile = new Image(strImgPath);
}

void CMemoSendAttachList::SetImgProgressPath(CString strFileNameFG,
											 CString strFileNameBGl,
											 CString strFileNameBGc,
											 CString strFileNameBGr)
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileNameFG.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileNameFG);

	m_pImgProgressFG = new Image(strImgPath);

	if (strFileNameBGl.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileNameBGl);

	m_pImgProgressBG[0] = new Image(strImgPath);

	if (strFileNameBGc.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileNameBGc);

	m_pImgProgressBG[1] = new Image(strImgPath);

	if (strFileNameBGr.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileNameBGr);

	m_pImgProgressBG[2] = new Image(strImgPath);
}

void CMemoSendAttachList::SetImgCancelPath(CString strFileName, CString strFileNameOver)
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileName.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileName);

	m_pImgCancel = new Image(strImgPath);

	if (strFileNameOver.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileNameOver);

	m_pImgCancelOver = new Image(strImgPath);
}

void CMemoSendAttachList::SetFontConfig(WCHAR* wszFontName, REAL nFontHeight, FontStyle style, Color crText)
{
	_tcscpy_s(m_wszFontName, wszFontName);
	m_nFontHeight = nFontHeight;
	m_fontStyle = style;

	m_crText = crText;
}

CString	CMemoSendAttachList::GetFileItemName(int nIdx)
{
	_memosend_file_item* pFileItem = NULL;

	int nCntItem = m_ptrArFileItem.GetCount();
	if (nIdx >= nCntItem)
		return _T("");

	pFileItem = (_memosend_file_item*)m_ptrArFileItem.GetAt(nIdx);
	if (!pFileItem)
		return _T("");

	return pFileItem->strName;
}

ULONGLONG CMemoSendAttachList::GetFileItemTotalSize(int nIdx)
{
	_memosend_file_item* pFileItem = NULL;

	int nCntItem = m_ptrArFileItem.GetCount();
	if (nIdx >= nCntItem)
		return 0;

	pFileItem = (_memosend_file_item*)m_ptrArFileItem.GetAt(nIdx);
	if (!pFileItem)
		return 0;

	return pFileItem->dwTotalSize;
}

ULONGLONG CMemoSendAttachList::GetFileItemCurSendSize(int nIdx)
{
	_memosend_file_item* pFileItem = NULL;

	int nCntItem = m_ptrArFileItem.GetCount();
	if (nIdx >= nCntItem)
		return 0;

	pFileItem = (_memosend_file_item*)m_ptrArFileItem.GetAt(nIdx);
	if (!pFileItem)
		return 0;

	return pFileItem->dwCurSendSize;
}

ULONGLONG CMemoSendAttachList::GetFileItemTotalSizeAll()
{
	_memosend_file_item* pFileItem = NULL;

	int nCntItem = m_ptrArFileItem.GetCount();
	if (nCntItem <= 0)
		return 0;

	ULONGLONG dwTotalSize = 0;
	for (int i = 0; i < nCntItem; i++)
	{
		pFileItem = (_memosend_file_item*)m_ptrArFileItem.GetAt(i);
		if (!pFileItem)
			continue;

		dwTotalSize += pFileItem->dwTotalKiloSize * 1024;
	}

	return dwTotalSize;
}

ULONGLONG CMemoSendAttachList::GetFileItemCurSendSizeAll()
{
	_memosend_file_item* pFileItem = NULL;

	int nCntItem = m_ptrArFileItem.GetCount();
	if (nCntItem <= 0)
		return 0;

	ULONGLONG dwCurSendSizeAll = 0;
	for (int i = 0; i < nCntItem; i++)
	{
		pFileItem = (_memosend_file_item*)m_ptrArFileItem.GetAt(i);
		if (!pFileItem)
			continue;

		ULONGLONG dwCurSendSize = pFileItem->dwCurSendSize;

		ULONGLONG dwKiloSize = pFileItem->dwCurSendSize / 1024;
		//if (dwRemainSize > 0)
		//	dwKiloSize += 1;
		if( dwKiloSize == 0 && dwCurSendSize > 0 )
			dwKiloSize = 1;
		dwCurSendSize = dwKiloSize * 1024;

		dwCurSendSizeAll += dwCurSendSize;
	}

	return dwCurSendSizeAll;
}

BOOL CMemoSendAttachList::SetFileItemStatus(_memosend_file_item* pFI, int nStatus)
{
	_memosend_file_item* pFileItem = NULL;

	int nCntItem = m_ptrArFileItem.GetCount();
	if (nCntItem <= 0)
		return TRUE;

	ULONGLONG dwCurSendSize = 0;
	for (int i = 0; i < nCntItem; i++)
	{
		pFileItem = (_memosend_file_item*)m_ptrArFileItem.GetAt(i);
		if (!pFileItem)
			continue;

		if (pFileItem == pFI)
		{
			pFileItem->eStatus = (_memosend_file_status)nStatus;
			RedrawWindow(&(pFileItem->rtItem), NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
			return TRUE;
		}
	}

	return FALSE;
}

BOOL CMemoSendAttachList::SetFileItemCancel(_memosend_file_item* pFI, BOOL bCancel)
{
	_memosend_file_item* pFileItem = NULL;

	int nCntItem = m_ptrArFileItem.GetCount();
	if (nCntItem <= 0)
		return TRUE;

	ULONGLONG dwCurSendSize = 0;
	for (int i = 0; i < nCntItem; i++)
	{
		pFileItem = (_memosend_file_item*)m_ptrArFileItem.GetAt(i);
		if (!pFileItem)
			continue;

		if (pFileItem == pFI)
		{
			pFileItem->bCancel = bCancel;
			RedrawWindow(&(pFileItem->rtImgCancel), NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
			return TRUE;
		}
	}

	return FALSE;
}

void CMemoSendAttachList::ClearFileItemAll()
{
	_memosend_file_item* pFileItem = NULL;

	int nCntItem = m_ptrArFileItem.GetCount();
	for (int i = 0; i < nCntItem; i++)
	{
		pFileItem = (_memosend_file_item*)m_ptrArFileItem.GetAt(i);
		if (!pFileItem)
			continue;

		delete pFileItem;
	}
	m_ptrArFileItem.RemoveAll();
	GET_APP()->m_pSendNoteManager->SetCurrentFileSize(0);
}

CMemoSendAttachList::_memosend_file_item* CMemoSendAttachList::AllocFileItem(CString strPath, CString strName, ULONGLONG dwFileSize, int serverIndex)
{
	CMemoSendAttachList::_memosend_file_item* pFileItem = new CMemoSendAttachList::_memosend_file_item;
	if (!pFileItem)
		return NULL;

	pFileItem->strFullPath = strPath;
	pFileItem->strName = strName;
	pFileItem->strShowName = strName;
	if (pFileItem->strShowName.GetLength() > 42)
	{
		pFileItem->strShowName = pFileItem->strShowName.Left(42) + _T("");
	}
	pFileItem->dwTotalSize = dwFileSize;
	pFileItem->serverIndex = serverIndex;

	ULONGLONG dwRemainSize = pFileItem->dwTotalSize % 1024;
	ULONGLONG dwKiloSize = pFileItem->dwTotalSize / 1024;
	//if (dwRemainSize > 0)
	//	dwKiloSize += 1;
	if( dwKiloSize == 0 && dwRemainSize > 0 )
		dwKiloSize = 1;

	pFileItem->dwTotalKiloSize = dwKiloSize;
	CString strKiloSize = _T("");
	strKiloSize.Format(_T("%d"), (INT)dwKiloSize);
	pFileItem->strSize = InsertCharToString(strKiloSize, 3, _T(','));
	pFileItem->strSize += _T("KB");

	return pFileItem;
}

BOOL CMemoSendAttachList::CheckFileAttach(CString strPath)
{	
	CString strMsg = _T("");

	// 10 
	int nCntFile = GetFileItemCount();	
	if (nCntFile < 10)
		m_bOnceFileCountMsgBox = false;

	if (nCntFile >= 10)
	{
		if (!m_bOnceFileCountMsgBox)
		{
			strMsg.LoadString(IDS_STRING238);
			NMessageBox(this, strMsg);
			m_bOnceFileCountMsgBox = true;
		}

		return FALSE;
	}
	

	CString strFilePath = strPath;
	ULONGLONG dwSelFileLength = 0L;
	if(strFilePath.GetLength() > 0)
	{
		int iFind = strFilePath.ReverseFind(_T('\\'));
		if (iFind == -1) 
			return FALSE;

		CString strName = strFilePath.Mid(iFind + 1);

		CFile file(strFilePath, CFile::modeRead | CFile::shareDenyNone);
		dwSelFileLength = file.GetLength();
	}
	else
		dwSelFileLength = 0L;	
	
	ULONGLONG dwTotalSize = GetTotalFileSize();
	
	LRESULT res = m_pSendMemoModel->IsEnableSendFileInfo(dwSelFileLength + dwTotalSize);
	if(res != 0L)
	{
		if(res == 1L)		
			strMsg.LoadString(IDS_STRING295);
		else if(res == 2L)	
			strMsg.LoadString(IDS_STRING299);
		else if(res == 3L)	
			strMsg.LoadString(IDS_STRING301);

		if (!m_bOnceFileSizeMsgBox)
		{
			NMessageBox(this, strMsg);
			m_bOnceFileSizeMsgBox=true;
		}
		
		return FALSE;
	}
	//m_bOnceFileSizeMsgBox=false;

	return TRUE;
}

BOOL CMemoSendAttachList::IsAlreadyFileList(CString strPath)
{
	_memosend_file_item* pFileItem = NULL;

	int nCntItem = m_ptrArFileItem.GetCount();
	for (int i = 0; i < nCntItem; i++)
	{
		pFileItem = (_memosend_file_item*)m_ptrArFileItem.GetAt(i);
		if (!pFileItem)
			continue;

		if (pFileItem->strFullPath.Compare(strPath) == 0)
			return TRUE;
	}

	return FALSE;
}

BOOL CMemoSendAttachList::AddFileItem(CString strPath)
{
	CString strFilePath = strPath;
	int iFind = strFilePath.ReverseFind(_T('\\'));
	if (iFind == -1) 
		return FALSE;

	CString strName = strFilePath.Mid(iFind + 1);

	CFile file(strFilePath, CFile::modeRead | CFile::shareDenyNone);
	ULONGLONG dwFileLength = file.GetLength();

	BOOL bReturn = FALSE;
	if (NULL == m_pSendMemoController)
		return FALSE;

	bReturn = AddFileItem(strFilePath, strName, dwFileLength, m_pSendMemoController->GetFileAttachIndex());

	if (bReturn)
	{
		GET_APP()->m_pSendNoteManager->SetCurrentFileSize( GetTotalFileSize() );
		m_pSendMemoController->UploadFile(strPath);
	}
	
	return bReturn;
}

BOOL CMemoSendAttachList::AddFileItem(CString strPath, CString strName, ULONGLONG dwFileSize, int serverIndex, _memosend_file_status eStatus)
{
	_memosend_file_item* pFileItem = NULL, *pFileItemLast = NULL;
	pFileItem = AllocFileItem(strPath, strName, dwFileSize, serverIndex);
	if (!pFileItem)
		return FALSE;

	pFileItem->eStatus = eStatus;
	if (eStatus == EMEMOSEND_FORWARD)
		pFileItem->dwCurSendSize = pFileItem->dwTotalSize;

	int nCntItem = m_ptrArFileItem.GetCount();
	if (nCntItem > 0)
		pFileItemLast = (_memosend_file_item*)m_ptrArFileItem.GetAt(nCntItem - 1);

	int nSX = 0, nSY = 0, nCX = 0, nCY = 0, nEX = 0, nEY = 0, nImgWidth = 0, nImgHeight = 0;
	
	nSX = DEF_MEMOSEND_LIST_ITEM_POS_LEFT_X;
	nSY = DEF_MEMOSEND_LIST_ITEM_POS_TOP_Y;
	if (pFileItemLast)
		nSY = pFileItemLast->rtItem.bottom + DEF_MEMOSEND_LIST_ITEM_POS_TOP_Y;
	nCX = m_rtWnd.Width() - (DEF_MEMOSEND_LIST_ITEM_POS_LEFT_X + DEF_MEMOSEND_LIST_ITEM_POS_RIGHT_X);
	
	

	CSize szName(0, 0);
	CRect rtName(0, 0, 500, 500);
	REAL nFontHeight = DEF_MEMOSEND_LIST_FILE_FONT_HEIGHT;
	RecalcTextRect(this, pFileItem->strShowName, DEF_MEMOSEND_LIST_FONT_NAME, nFontHeight, DEF_MEMOSEND_LIST_FILE_FONT_STYLE, rtName, szName);
	pFileItem->szName = szName;

	nCY = szName.cy;
	
	pFileItem->rtItem.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);

	//cancel button
	if (m_pImgCancel)
	{
		nImgWidth = m_pImgCancel->GetWidth();
		nImgHeight = m_pImgCancel->GetHeight();

		nSX = pFileItem->rtItem.right - nImgWidth;
		nSY = pFileItem->rtItem.top + (pFileItem->rtItem.Height() - nImgHeight) / 2;
		nCX = nImgWidth;
		nCY = nImgHeight;
		pFileItem->rtImgCancel.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);
	}

	//file size

	CSize szSize(0, 0);
	CRect rtSize(0, 0, 500, 500);
	RecalcTextRect(this, pFileItem->strShowName, DEF_MEMOSEND_LIST_FONT_NAME, nFontHeight, DEF_MEMOSEND_LIST_FILE_FONT_STYLE, rtSize, szSize);
	

	

	//RecalcTextRect(this, pFileItem->strSize, DEF_MEMOSEND_LIST_FONT_NAME, nFontHeight, DEF_MEMOSEND_LIST_FILE_FONT_STYLE, rtSize, szSize);
	nSX = pFileItem->rtImgCancel.left - DEF_MEMOSEND_LIST_SIZE_WIDTH - DEF_MEMOSEND_LIST_FILESIZE_POS_RIGHT_X;
	nSY = pFileItem->rtItem.top + (pFileItem->rtItem.Height() - szSize.cy) / 2;
	nCX = DEF_MEMOSEND_LIST_SIZE_WIDTH;
	nCY = szSize.cy;
	pFileItem->rtSize.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);

	nSX = pFileItem->rtSize.left - DEF_MEMOSEND_LIST_SIZE_PROG_GAP_X - DEF_MEMOSEND_LIST_PROG_WIDTH;
	nSY = pFileItem->rtItem.top + (pFileItem->rtItem.Height() - DEF_MEMOSEND_LIST_PROG_HEIGHT) / 2;
	nCX = DEF_MEMOSEND_LIST_PROG_WIDTH;
	nCY = DEF_MEMOSEND_LIST_PROG_HEIGHT;
	pFileItem->rtProgress.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);

	nSX = DEF_MEMOSEND_LIST_ITEM_POS_LEFT_X;
	nSY = pFileItem->rtItem.top;
	nEX = pFileItem->rtProgress.left - DEF_MEMOSEND_LIST_PROG_NAME_GAP_X;
	nCY = szName.cy;
	pFileItem->rtName.SetRect(nSX, nSY, nEX, nSY + nCY);

	m_ptrArFileItem.Add(pFileItem);

	CWnd* pWndParent = GetParent();

	m_dwTotalSize += pFileItem->dwTotalSize;
	if (pWndParent && pWndParent->GetSafeHwnd())
		pWndParent->SendMessage(UM_MEMOSEND_FILESIZE, (WPARAM)0, (LPARAM)0);

	nCntItem = m_ptrArFileItem.GetCount();	
	if (nCntItem == 1 && pWndParent && pWndParent->GetSafeHwnd())
	{
        CRect rtParent(0, 0, 0, 0);
		pWndParent->GetWindowRect(&rtParent);
		pWndParent->SendMessage(WM_SIZE, (WPARAM)SIZE_RESTORED, MAKELPARAM(rtParent.Width(), rtParent.Height()));
		pWndParent->RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
	}

	UpdateScrollInfo();

	RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);

	return TRUE;
}

BOOL CMemoSendAttachList::DeleteFileItem(_memosend_file_item* pFI)
{
	_memosend_file_item* pFileItem = NULL;

	int nCntItem = m_ptrArFileItem.GetCount();
	for (int i = 0; i < nCntItem; i++)
	{
		pFileItem = (_memosend_file_item*)m_ptrArFileItem.GetAt(i);
		if (!pFileItem)
			continue;

		if (pFileItem == pFI)
		{
			if (NULL != m_pSendMemoController)
			{
				m_DeleteAttachFileInfo.pFileItem = pFileItem;
				m_DeleteAttachFileInfo.index = i;

				m_pSendMemoController->Delete(pFileItem->serverIndex, &m_tridDelAttachedFile);
			}

			return TRUE;
		}
	}

	return FALSE;
}

bool CMemoSendAttachList::OnGTWASActor_ResponseDeleteAttachedFile(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, bool bResult)
{
	if( trid != m_tridDelAttachedFile )
		return true;

	if( bResult != true )
	{
		GET_APP()->m_pMessageBoxManager->CreateMessageBox(this, _T("÷  Ͽϴ.   ٽ õϼ.")/*LoadStringFromResource(IDS_STRING)*/);	// ٱ

	}
	else
	{
		Delete(m_DeleteAttachFileInfo.pFileItem, m_DeleteAttachFileInfo.index);

		GET_APP()->m_pSendNoteManager->SetCurrentFileSize( GetTotalFileSize() );

		if(0 == m_ptrArFileItem.GetCount())
		{
			m_pSendMemoController->EnableSend();
		}

		RecalcPostFileItem(m_DeleteAttachFileInfo.pFileItemNext, DEF_MEMOSEND_LIST_ITEM_HEIGHT * (-1));

		UpdateScrollInfo();
		RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
	}

	return false;
}

//BOOL CMemoSendAttachList::DeleteFileItemFromPath(CString strPath)
//{
//	_memosend_file_item* pFileItem = NULL;
//
//	int nCntItem = m_ptrArFileItem.GetCount();
//	for (int i = 0; i < nCntItem; i++)
//	{
//		pFileItem = (_memosend_file_item*)m_ptrArFileItem.GetAt(i);
//		if (!pFileItem)
//			continue;
//
//		if (pFileItem->strFullPath.Compare(strPath) == 0)
//		{
//			Delete(pFileItem, i);
//			return TRUE;
//		}
//	}
//
//	return FALSE;
//}

BOOL CMemoSendAttachList::DeleteFileItemFromIndex(int nServerIndex)
{
	for (int i = 0; i < m_ptrArFileItem.GetCount(); i++)
	{
		_memosend_file_item* pFileItem = (_memosend_file_item*)m_ptrArFileItem.GetAt(i);

		if (pFileItem->serverIndex == nServerIndex)
		{
			if (NULL != m_pSendMemoController)
				Delete(pFileItem, i);

			return TRUE;
		}
	}

	return FALSE;
}

BOOL CMemoSendAttachList::DeleteFileListItemFromIndex(int nServerIndex)
{
	for (int i = 0; i < m_ptrArFileItem.GetCount(); i++)
	{
		_memosend_file_item* pFileItem = (_memosend_file_item*)m_ptrArFileItem.GetAt(i);

		if (pFileItem->serverIndex == nServerIndex)
		{
			if (NULL != m_pSendMemoController)
				DeleteFileList(pFileItem, i);

			return TRUE;
		}
	}

	return FALSE;
}


//BOOL CMemoSendAttachList::DeleteFileItemFromName(CString strName)
//{
//	_memosend_file_item* pFileItem = NULL;
//
//	int nCntItem = m_ptrArFileItem.GetCount();
//	for (int i = 0; i < nCntItem; i++)
//	{
//		pFileItem = (_memosend_file_item*)m_ptrArFileItem.GetAt(i);
//		if (!pFileItem)
//			continue;
//
//		if (pFileItem->strName.Compare(strName) == 0)
//		{
//			Delete(pFileItem, i);
//			return TRUE;
//		}
//	}
//
//	return FALSE;
//}

void CMemoSendAttachList::Delete(_memosend_file_item* pFileItem, int nIndex)
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);

	int nCntItem = m_ptrArFileItem.GetCount();

	if (nIndex < nCntItem && pFileItem)
	{
		m_dwTotalSize -= pFileItem->dwTotalSize;

		m_ptrArFileItem.RemoveAt(nIndex);
		delete pFileItem;
	}

	CWnd* pWndParent = GetParent();
	if (pWndParent && pWndParent->GetSafeHwnd())
		pWndParent->SendMessage(UM_MEMOSEND_FILESIZE, (WPARAM)0, (LPARAM)0);

	nCntItem = m_ptrArFileItem.GetCount();	
	if (nCntItem == 0 && pWndParent && pWndParent->GetSafeHwnd())
	{
		CRect rtParent(0, 0, 0, 0);
		pWndParent->GetWindowRect(&rtParent);
		pWndParent->SendMessage(WM_SIZE, (WPARAM)SIZE_RESTORED, MAKELPARAM(rtParent.Width(), rtParent.Height()));
		pWndParent->RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
	}
	GET_APP()->m_pSendNoteManager->SetCurrentFileSize( GetTotalFileSize() );

	if(0 == m_ptrArFileItem.GetCount())
	{
		m_pSendMemoController->EnableSend();
	}
}

void CMemoSendAttachList::DeleteFileList( _memosend_file_item* pFileItem, int nIndex )
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);
	Delete(pFileItem, nIndex);

	RecalcPostFileItem(m_DeleteAttachFileInfo.pFileItemNext, DEF_MEMOSEND_LIST_ITEM_HEIGHT * (-1));

	UpdateScrollInfo();
	RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}



void CMemoSendAttachList::UpdateFileAttachComplete(CString strPath)
{
	_memosend_file_item* pFileItem = NULL;

	int nCntItem = m_ptrArFileItem.GetCount();
	for (int i = 0; i < nCntItem; i++)
	{
		pFileItem = (_memosend_file_item*)m_ptrArFileItem.GetAt(i);
		if (!pFileItem)
			continue;

		if (pFileItem->strFullPath.Compare(strPath) == 0)
		{
			pFileItem->eStatus = EMEMOSEND_COMPLETE;
			RedrawWindow(&(pFileItem->rtImgCancel), NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
			return;
		}
	}
}

void CMemoSendAttachList::UpdateFileAttachProgress(int serverIndex, DWORD dwSendLength)
{
	//return;
	for (int index = 0; index < m_ptrArFileItem.GetCount(); index++)
	{
		_memosend_file_item* pFileItem = (_memosend_file_item*)m_ptrArFileItem.GetAt(index);
		
		if (pFileItem->serverIndex == serverIndex)
		{
			pFileItem->dwCurSendSize = dwSendLength;
			if (pFileItem->dwTotalSize == pFileItem->dwCurSendSize)
			{
				pFileItem->eStatus = EMEMOSEND_COMPLETE;
				if (NULL != m_pSendMemoController) m_pSendMemoController->UploadComplete(pFileItem->serverIndex);
			}
			else
			{
				pFileItem->eStatus = EMEMOSEND_SENDING;
			}


			RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE);
			/*CRect rtUpdate = pFileItem->rtProgress;
			rtUpdate.UnionRect(&rtUpdate, &(pFileItem->rtImgCancel));
			RedrawWindow(&rtUpdate, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE);*/

			CWnd* pWndParent = GetParent();
			if (pWndParent && pWndParent->GetSafeHwnd())
				pWndParent->SendMessage(UM_MEMOSEND_FILESIZE, (WPARAM)0, (LPARAM)0);
		}
	}
}

void CMemoSendAttachList::RecalcFileItem()
{
	_memosend_file_item* pFileItem = NULL, *pFileItemFirst = NULL, *pFileItemLast = NULL;

	int nCntItem = m_ptrArFileItem.GetCount();
	if (nCntItem <= 0)
		return;

	pFileItemFirst = (_memosend_file_item*)m_ptrArFileItem.GetAt(0);
	if (!pFileItemFirst)
		return;

	pFileItemLast = (_memosend_file_item*)m_ptrArFileItem.GetAt(nCntItem - 1);
	if (!pFileItemLast)
		return;

	int nDiffWidth = 0, nDiffHeight = 0;
	int nSX = 0, nSY = 0, nCX = 0, nCY = 0, nEX = 0, nEY = 0, nImgWidth = 0, nImgHeight = 0;

	if (pFileItemFirst->rtItem.top < 0 && pFileItemLast->rtItem.bottom < m_rtWnd.Height())
	{
		nDiffHeight = m_rtWnd.Height() - pFileItemLast->rtItem.bottom;
		//ScrollItem(nDiffHeight);
	}

	CRect rtClient(0, 0, 0, 0);
	GetClientRect(&rtClient);

	int nWidth = rtClient.Width() - (DEF_MEMOSEND_LIST_ITEM_POS_LEFT_X + DEF_MEMOSEND_LIST_ITEM_POS_RIGHT_X);
	nDiffWidth = nWidth - pFileItemFirst->rtItem.Width();

	int nOffsetY = 0;
	for (int i = 0; i < nCntItem; i++)
	{
		pFileItem = (_memosend_file_item*)m_ptrArFileItem.GetAt(i);
		if (!pFileItem)
			continue;

		pFileItem->rtItem.right = pFileItem->rtItem.left + nWidth /*- DEF_MEMOSEND_LIST_SCROLL_SIZE*/;

		if (m_pImgCancel)
		{
			nImgWidth = m_pImgCancel->GetWidth();
			nImgHeight = m_pImgCancel->GetHeight();

			nSX = pFileItem->rtItem.right - nImgWidth;
			nSY = pFileItem->rtItem.top + (pFileItem->rtItem.Height() - nImgHeight) / 2;
			nCX = nImgWidth;
			nCY = nImgHeight;
			pFileItem->rtImgCancel.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);
		}

		nSX = pFileItem->rtImgCancel.left - DEF_MEMOSEND_LIST_SIZE_WIDTH - DEF_MEMOSEND_LIST_FILESIZE_POS_RIGHT_X;
		nSY = pFileItem->rtItem.top + (pFileItem->rtItem.Height() - pFileItem->rtSize.Height()) / 2;
		nCX = pFileItem->rtSize.Width();
		nCY = pFileItem->rtSize.Height();
		pFileItem->rtSize.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);

		nSX = pFileItem->rtSize.left - DEF_MEMOSEND_LIST_SIZE_PROG_GAP_X - DEF_MEMOSEND_LIST_PROG_WIDTH;
		nSY = pFileItem->rtItem.top + (pFileItem->rtItem.Height() - DEF_MEMOSEND_LIST_PROG_HEIGHT) / 2;
		nCX = DEF_MEMOSEND_LIST_PROG_WIDTH;
		nCY = DEF_MEMOSEND_LIST_PROG_HEIGHT;
		pFileItem->rtProgress.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);

		nSX = DEF_MEMOSEND_LIST_ITEM_POS_LEFT_X;
		nSY = pFileItem->rtItem.top;
		nEX = pFileItem->rtProgress.left - DEF_MEMOSEND_LIST_PROG_NAME_GAP_X;
		nCY = pFileItem->szName.cy;
		pFileItem->rtName.SetRect(nSX, nSY, nEX, nSY + nCY);
	}

	//UpdateScrollInfo();

	RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}

void CMemoSendAttachList::UpdateScrollInfo()
{
	_memosend_file_item* pFileItem = NULL, *pFileItemFirst = NULL, *pFileItemLast = NULL;

	m_nScrollPageSize = m_rtWnd.Height();

	int nCntItem = m_ptrArFileItem.GetCount();
	if (nCntItem <= 0)
		return;

	pFileItemFirst = (_memosend_file_item*)m_ptrArFileItem.GetAt(0);
	if (!pFileItemFirst)
		return;

	pFileItemLast = (_memosend_file_item*)m_ptrArFileItem.GetAt(nCntItem - 1);
	if (!pFileItemLast)
		return;

	int nWndHeight = m_rtWnd.Height();
	//int nItemHeight = pFileItemLast->rtItem.bottom - pFileItemFirst->rtItem.top;

	int nCount = m_ptrArFileItem.GetCount();
	if ( nCount > 5)
	{
		if (!m_wndScrollBar.IsWindowVisible())
		{
			m_wndScrollBar.ShowScrollBar(TRUE);
		}
	}
	else
	{
		if (m_wndScrollBar.IsWindowVisible())
		{
			m_wndScrollBar.ShowScrollBar(FALSE);
			if (pFileItemFirst->rtItem.top < DEF_MEMOSEND_LIST_ITEM_POS_TOP_Y)
			{
				int nDiff = DEF_MEMOSEND_LIST_ITEM_POS_TOP_Y - pFileItemFirst->rtItem.top;
				ScrollItem(nDiff);
			}
		}
	}

	int nRange = 0;
	for(int i = 0; i < nCount; i++ )
	{
		nRange += DEF_MEMOSEND_LIST_ITEM_POS_TOP_Y;
		nRange += ((_memosend_file_item*)m_ptrArFileItem.GetAt(i))->rtItem.Height();
	}

	nRange += DEF_MEMOSEND_LIST_ITEM_POS_TOP_Y;

	m_wndScrollBar.SetScrollRange(0, nRange);
	int nPos = abs(pFileItemFirst->rtItem.top - DEF_MEMOSEND_LIST_ITEM_POS_TOP_Y);
	m_wndScrollBar.SetScrollPos(nPos);
	SCROLLINFO si;
	si.cbSize = sizeof(SCROLLINFO);
	si.fMask = SIF_ALL;
	si.nMin = 0;
	si.nMax = nRange;
	si.nPage = nWndHeight;
	si.nPos = nPos;
	si.nTrackPos = si.nPos;
	m_wndScrollBar.SetScrollInfo(&si);
}

BOOL CMemoSendAttachList::ScrollItem(int nDiff)
{
	if (nDiff == 0)
		return FALSE;

	_memosend_file_item* pFileItem = NULL, *pFileItemFirst = NULL, *pFileItemLast = NULL;

	int nCntItem = m_ptrArFileItem.GetCount();
	if (nCntItem <= 0)
		return FALSE;

	pFileItemFirst = (_memosend_file_item*)m_ptrArFileItem.GetAt(0);
	if (!pFileItemFirst)
		return FALSE;

	pFileItemLast = (_memosend_file_item*)m_ptrArFileItem.GetAt(nCntItem - 1);
	if (!pFileItemLast)
		return FALSE;

	int nAdjustDiff = 0;
	if (nDiff > 0)
	{
		if (pFileItemFirst->rtItem.top >= DEF_MEMOSEND_LIST_ITEM_POS_TOP_Y)
			return FALSE;

		nAdjustDiff = nDiff - abs(pFileItemFirst->rtItem.top - DEF_MEMOSEND_LIST_ITEM_POS_TOP_Y);
		if (nAdjustDiff > 0)
			nDiff = abs(pFileItemFirst->rtItem.top - DEF_MEMOSEND_LIST_ITEM_POS_TOP_Y);
	}
	else
	{
		if (pFileItemLast->rtItem.bottom <= m_rtWnd.Height() - DEF_MEMOSEND_LIST_ITEM_POS_TOP_Y)
			return FALSE;

		nAdjustDiff = abs(nDiff) - abs(pFileItemLast->rtItem.bottom + DEF_MEMOSEND_LIST_ITEM_POS_TOP_Y - m_rtWnd.Height());
		if (nAdjustDiff > 0)
			nDiff = abs(pFileItemLast->rtItem.bottom - m_rtWnd.Height() + DEF_MEMOSEND_LIST_ITEM_POS_TOP_Y) * (-1);
	}

	for (int i = 0; i < nCntItem; i++)
	{
		pFileItem = (_memosend_file_item*)m_ptrArFileItem.GetAt(i);
		if (!pFileItem)
			continue;

		pFileItem->rtItem.OffsetRect(0, nDiff);
		pFileItem->rtImgFile.OffsetRect(0, nDiff);
		pFileItem->rtName.OffsetRect(0, nDiff);
		pFileItem->rtProgress.OffsetRect(0, nDiff);
		pFileItem->rtSize.OffsetRect(0, nDiff);
		pFileItem->rtImgCancel.OffsetRect(0, nDiff);
	}

	return TRUE;
}

void CMemoSendAttachList::RecalcPostFileItem(_memosend_file_item* pFI, int nOffsetY)
{
	int nCntItem = m_ptrArFileItem.GetCount();
	if (nCntItem <= 0)
		return;

	_memosend_file_item* pFileItem = NULL;

	BOOL bFindItem = FALSE;
	for (int i = 0; i < nCntItem; i++)
	{
		pFileItem = (_memosend_file_item*)m_ptrArFileItem.GetAt(i);
		if (!pFileItem)
			continue;

		if (pFileItem == pFI)
			bFindItem = TRUE;

		if (bFindItem)
		{
			pFileItem->rtItem.OffsetRect(0, nOffsetY);
			pFileItem->rtImgFile.OffsetRect(0, nOffsetY);
			pFileItem->rtName.OffsetRect(0, nOffsetY);
			pFileItem->rtProgress.OffsetRect(0, nOffsetY);
			pFileItem->rtSize.OffsetRect(0, nOffsetY);
			pFileItem->rtImgCancel.OffsetRect(0, nOffsetY);
		}
	}
}

// CMemoSendAttachList ޽ óԴϴ.

LRESULT CMemoSendAttachList::OnUmMemoSendFileDrop(WPARAM wParam, LPARAM lParam)
{
	TCHAR* tszFilePath = (TCHAR*)lParam;
	if (!tszFilePath || _tcslen(tszFilePath) <= 0)
		return 0L;

	if (IsAlreadyFileList(tszFilePath))
		return 0L;

	if(PathIsDirectory(tszFilePath))
		return 0L;

	if (!CheckFileAttach(tszFilePath))
		return 0L;

	if (!AddFileItem(tszFilePath))
		return 0L;

	return 1L;
}

int CMemoSendAttachList::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndScrollBar.Create(WS_CHILD | SBS_VERT, CRect(0, 0, 0, 0), this, ID_MEMOSEND_SCROLLBAR))
		return -1;

	return 0;
}

void CMemoSendAttachList::OnDestroy()
{
	g_pMessengerActor->GetWASActor()->UnRegisterObserver(this);	
	//g_pMessengerActor->UnRegisterObserver(this);

	if (m_pImgBG)
	{
		delete m_pImgBG;
		m_pImgBG = NULL;
	}

	for (int i = 0; i < 3; i++)
	{
		SAFE_DELETE(m_pImgProgressBG[i])
	}

	if (m_pImgProgressFG)
	{
		delete m_pImgProgressFG;
		m_pImgProgressFG = NULL;
	}

	if (m_pImgFile)
	{
		delete m_pImgFile;
		m_pImgFile = NULL;
	}

	if (m_pImgCancel)
	{
		delete m_pImgCancel;
		m_pImgCancel = NULL;
	}
	if (m_pImgCancelOver)
	{
		delete m_pImgCancelOver;
		m_pImgCancelOver = NULL;
	}

	if (m_pImgInitMsg)
	{
		delete m_pImgInitMsg;
		m_pImgInitMsg = NULL;
	}

	ClearFileItemAll();

	CWnd::OnDestroy();
}

BOOL CMemoSendAttachList::OnEraseBkgnd(CDC* pDC)
{
	return TRUE;
}

void CMemoSendAttachList::OnPaint()
{
	_Draw();
}

void CMemoSendAttachList::OnMouseMove(UINT nFlags, CPoint point)
{
	if (!m_bTracking)
	{
		m_bTracking = TRUE;

		TRACKMOUSEEVENT tme;
		tme.cbSize = sizeof(TRACKMOUSEEVENT);
		tme.dwFlags = TME_HOVER | TME_LEAVE;
		tme.dwHoverTime = 1;
		tme.hwndTrack = GetSafeHwnd();
		TrackMouseEvent(&tme);
	}

	CWnd::OnMouseMove(nFlags, point);
}

void CMemoSendAttachList::OnMouseHover(UINT nFlags, CPoint point)
{
	
}

void CMemoSendAttachList::OnMouseLeave()
{
	m_bTracking = FALSE;

	if (GetAsyncKeyState(VK_LBUTTON) & 0x8000)
	{
	}
	else
	{
		_memosend_file_item* pFileItem = NULL;

		int nCntItem = m_ptrArFileItem.GetCount();
		for (int i = 0; i < nCntItem; i++)
		{
			pFileItem = (_memosend_file_item*)m_ptrArFileItem.GetAt(i);
			if (!pFileItem)
				continue;

			if (pFileItem->bDown)
			{
				ReleaseCapture();								
			}
			pFileItem->bDown = FALSE;
		}
	}
}

void CMemoSendAttachList::OnLButtonDown(UINT nFlags, CPoint point)
{
	SetFocus();

	_memosend_file_item* pFileItem = NULL;

	int nCntItem = m_ptrArFileItem.GetCount();
	for (int i = 0; i < nCntItem; i++)
	{
		pFileItem = (_memosend_file_item*)m_ptrArFileItem.GetAt(i);
		if (!pFileItem)
			continue;

		if (pFileItem->bCancel && pFileItem->rtImgCancel.PtInRect(point))
		{
			SetCapture();
			pFileItem->bDown = TRUE;
			return;
		}
	}

	CWnd::OnLButtonDown(nFlags, point);
}

void CMemoSendAttachList::OnLButtonUp(UINT nFlags, CPoint point)
{
	ReleaseCapture();		

	_memosend_file_item* pFileItem = NULL, *pFileItemNext = NULL;

	BOOL bDelUpdate = FALSE;
	int nCntItem = m_ptrArFileItem.GetCount();
	for (int i = nCntItem - 1; i >= 0; i--)
	{
		pFileItem = (_memosend_file_item*)m_ptrArFileItem.GetAt(i);
		if (!pFileItem)
			continue;

		if (pFileItem->bDown && pFileItem->rtImgCancel.PtInRect(point))
		{
			if (m_bEnbleCancel)
			{
				m_DeleteAttachFileInfo.InitData();
				m_DeleteAttachFileInfo.pFileItemNext = pFileItemNext;

				DeleteFileItem(pFileItem);
				bDelUpdate = TRUE;
			}
			else
			{
				NMessageBox(this, LoadStringFromResource(IDS_STRING636));
			}
		}
		else
		{
			pFileItem->bDown = FALSE;
			if (!bDelUpdate)
				pFileItemNext = pFileItem;
		}
	}

	CWnd::OnLButtonUp(nFlags, point);
}

BOOL CMemoSendAttachList::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message)
{
	CPoint pt(0, 0);
	GetCursorPos(&pt);
	ScreenToClient(&pt);

	_memosend_file_item* pFileItem = NULL;

	int nCntItem = m_ptrArFileItem.GetCount();
	for (int i = 0; i < nCntItem; i++)
	{
		pFileItem = (_memosend_file_item*)m_ptrArFileItem.GetAt(i);
		if (!pFileItem)
			continue;

		if (pFileItem->bCancel && pFileItem->rtImgCancel.PtInRect(pt))
		{
			::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_HAND));
			return TRUE;
		}
	}

	return CWnd::OnSetCursor(pWnd, nHitTest, message);
}

BOOL CMemoSendAttachList::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
	long lScrollValue = m_nScrollOneSize * zDelta / 120;

	if (ScrollItem(lScrollValue))
	{
		UpdateScrollInfo();

		RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
	}

	return CWnd::OnMouseWheel(nFlags, zDelta, pt);
}

void CMemoSendAttachList::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	long lScrollValue = 0;

	switch (nChar)
	{
	case VK_LEFT:
		{
			int a = 0;
		}
		break;
	case VK_RIGHT:
		{
			int a = 0;
		}
		break;
	case VK_DOWN:
		{
			lScrollValue = m_nScrollOneSize * (-1);
		}
		break;
	case VK_UP:
		{
			lScrollValue = m_nScrollOneSize * (1);
		}
		break;
	case VK_NEXT:
		{
			lScrollValue = m_nScrollPageSize * (-1);
		}
		break;
	case VK_PRIOR:
		{
			lScrollValue = m_nScrollPageSize * (1);
		}
		break;
	}

	if (ScrollItem(lScrollValue))
	{
		UpdateScrollInfo();

		RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
	}

	CWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CMemoSendAttachList::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	long lScrollValue = 0;

	switch (nSBCode)
	{
	case SB_TOP:
	case SB_LINEUP:
		{
			lScrollValue = m_nScrollOneSize * (1);
		}
		break;
	case SB_BOTTOM:
	case SB_LINEDOWN:
		{
			lScrollValue = m_nScrollOneSize * (-1);
		}
		break;
	case SB_PAGEUP:
		{
			lScrollValue = m_nScrollPageSize * (1);
		}
		break;
	case SB_PAGEDOWN:
		{
			lScrollValue = m_nScrollPageSize * (-1);
		}
		break;
	case SB_THUMBTRACK:
		{
			int nCurPos = m_wndScrollBar.GetScrollPos();
			lScrollValue = nCurPos - nPos;
		}
		break;
	}

	if (ScrollItem(lScrollValue))
	{
		UpdateScrollInfo();

		RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
	}

	CWnd::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CMemoSendAttachList::OnSize(UINT nType, int cx, int cy)
{
	CWnd::OnSize(nType, cx, cy);

	m_rtWnd.SetRect(0, 0, cx, cy);

	int nSX = 0, nSY = 0, nCX = 0, nCY = 0;
	if (m_pImgInitMsg && !m_strInitMsgText.IsEmpty())
	{
		int nImgWidth = m_pImgInitMsg->GetWidth();
		int nImgHeight = m_pImgInitMsg->GetHeight();
		int nImgSX = 0;
		int nImgSY = 0;

		if (m_szInitMsgText.cx == 0)
		{
			REAL nInitFontHeight = DEF_MEMOSEND_LIST_INIT_FONT_HEIGHT;
			CRect rtInitMsg(0, 0, 500, 500);
			RecalcTextRect(this, m_strInitMsgText, g_defaultFontFaceName, nInitFontHeight, FontStyleRegular, rtInitMsg, m_szInitMsgText);
		}

		int nTotalWidth = nImgWidth + DEF_MEMOSEND_LIST_INIT_GAP_X + m_szInitMsgText.cx + 5;
		int nTotalHeight = nImgHeight;
		if (m_szInitMsgText.cy > nImgHeight)
			nTotalHeight = m_szInitMsgText.cy;
		nSX = (m_rtWnd.Width() - nTotalWidth) / 2;
		nSY = (m_rtWnd.Height() - nTotalHeight) / 2;
		m_rtInitMsg.SetRect(nSX, nSY, nSX + nTotalWidth, nSY + nTotalHeight);

		nImgSX = nSX;
		nImgSY = nSY;
		if (m_szInitMsgText.cy > nImgHeight)
			nImgSY += ((nTotalHeight - nImgHeight) / 2);
		m_rtInitMsgImg.SetRect(nImgSX, nImgSY, nImgSX + nImgWidth, nImgSY + nImgHeight);

		int nTxtSX = m_rtInitMsgImg.right + DEF_MEMOSEND_LIST_INIT_GAP_X;
		int nTxtSY = nSY;
		if (nImgHeight > m_szInitMsgText.cy)
			nTxtSY += ((nTotalHeight - m_szInitMsgText.cy) / 2);
		m_rtInitMsgText.SetRect(nTxtSX, nTxtSY, nTxtSX + m_szInitMsgText.cx + 5, nTxtSY + m_szInitMsgText.cy);
	}

	if (m_wndScrollBar.GetSafeHwnd())
	{
		nCX = GetSystemMetrics(SM_CXVSCROLL);
		nSX = m_rtWnd.right - nCX;
		nSY = m_rtWnd.top;
		nCY = m_rtWnd.Height();	
		m_rtScrollBar.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);

		m_wndScrollBar.MoveWindow(&m_rtScrollBar);
	}

	RecalcFileItem();
}

void CMemoSendAttachList::SetController( SendMemoController* pController )
{
	m_pSendMemoController = pController;
}

void CMemoSendAttachList::SetModel(CNoteModel* pModel)
{
	m_pSendMemoModel = pModel;
}

BOOL CMemoSendAttachList::FileAddInitialize()
{
	m_bOnceFileCountMsgBox = false;
	m_bOnceFileSizeMsgBox = false;
	return TRUE;
}

LRESULT CMemoSendAttachList::OnInitFileAdd(WPARAM wParam, LPARAM lParam)
{
	if (FileAddInitialize())
		return 1L;
	else
		return 0L;

}

void CMemoSendAttachList::FileSendResultWait( int index )
{
	m_bEnbleCancel = FALSE;
}

void CMemoSendAttachList::FileSendResultComplete( int index )
{
	m_bEnbleCancel = TRUE;
}

void CMemoSendAttachList::_Draw()
{
	CPaintDC dc(this); // device context for painting

	PAINTSTRUCT ps = dc.m_ps;
	int psWidth = ps.rcPaint.right - ps.rcPaint.left;
	int psHeight = ps.rcPaint.bottom - ps.rcPaint.top;

	int nPX = ps.rcPaint.left;
	int nPY = ps.rcPaint.top;

	CRect rtPS(nPX, nPY, nPX + psWidth, nPY + psHeight);

	CRect rt(0, 0, 0, 0);
	GetClientRect(&rt);
	int nWndWidth = rt.Width();
	int nWndHeight = rt.Height();

	HDC hdc = dc.GetSafeHdc();

	HDC	hdcMemory = CreateCompatibleDC(hdc);

	if (hdcMemory == NULL)
		return;

	HBITMAP hbmpMem = CreateCompatibleBitmap(hdc, psWidth, psHeight);

	HGDIOBJ hbmpOld = ::SelectObject(hdcMemory,  hbmpMem);

	Graphics graph(hdcMemory);

	if (hbmpMem)
	{
		graph.SetSmoothingMode(SmoothingModeAntiAlias);
		graph.SetInterpolationMode(InterpolationModeHighQualityBicubic);
		graph.SetPageUnit(UnitPixel);

		_DrawBackground(&graph, &rtPS);

		int nCntFileAttach = m_ptrArFileItem.GetCount();
		if (nCntFileAttach <= 0)
		{
			_DrawNoFile(&graph, &rtPS);
		}
		else
		{
			for (int i = 0; i < nCntFileAttach; i++)
			{
				PMEMOSEND_FILE_ITEM pFileItem = (PMEMOSEND_FILE_ITEM)m_ptrArFileItem.GetAt(i);
				_DrawFileItem(&graph, &rtPS, pFileItem);
			}
		}

		BitBlt(dc.GetSafeHdc(), nPX, nPY, psWidth, psHeight, hdcMemory, 0, 0, SRCCOPY);

		::SelectObject(hdcMemory, hbmpOld);
		::DeleteObject(hbmpMem);
	}

	::DeleteDC(hdcMemory);
}

void CMemoSendAttachList::_DrawBackground(Graphics* pGraphics , CRect *pRcPS)
{
	ImageAttributes ImgAttr;

	SolidBrush brushBG(m_crBG);
	Pen penBG(m_crOutline, 1);
	int nSX = 0, nSY = 0, nCX = 0, nCY = 0;
	if (m_pImgBG)
		DrawImageToStretchHorz(pGraphics, m_pImgBG, pRcPS, &m_rtWnd, m_crBG, &ImgAttr);
	else
	{
		nSX = m_rtWnd.left - pRcPS->left;
		nSY = m_rtWnd.top - pRcPS->top;
		nCX = m_rtWnd.Width();
		nCY = m_rtWnd.Height();
		pGraphics->FillRectangle(&brushBG, nSX - 1, nSY - 1, nCX + 1, nCY + 1);
	}
}

void CMemoSendAttachList::_DrawNoFile( Graphics* pGraphics, CRect *pRcPS )
{
	ImageAttributes ImgAttr;
	int nSX = 0, nSY = 0, nCX = 0, nCY = 0;
	Pen penOutline(DEF_MEMOSEND_LIST_INIT_OUTLINE_COLOR, 1);
	nSX = m_rtWnd.left - pRcPS->left + DEF_MEMOSEND_LIST_SCROLL_SIZE;
	nSY = m_rtWnd.top - pRcPS->top;
	nCX = m_rtWnd.Width() - (2 * DEF_MEMOSEND_LIST_SCROLL_SIZE);
	nCY = m_rtWnd.Height();
	//pGraphics->DrawRectangle(&penOutline, nSX, nSY, nCX - 1, nCY - 1);

	if (m_pImgInitMsg)
		DrawImageToDest(pGraphics, m_pImgInitMsg, pRcPS, &m_rtInitMsgImg, &ImgAttr);

	if (!m_strInitMsgText.IsEmpty())
	{
		DrawTextToDest2(pGraphics,
			m_strInitMsgText, pRcPS, &m_rtInitMsgText,
			DEF_MEMOSEND_LIST_FONT_NAME, DEF_MEMOSEND_LIST_INIT_FONT_HEIGHT,
			StringAlignmentCenter,
			FontStyleRegular,
			DEF_MEMOSEND_LIST_INIT_FONT_COLOR);
	}
}


void CMemoSendAttachList::_DrawFileItem( Graphics* pGraphics, CRect *pRcPS, PMEMOSEND_FILE_ITEM pFileItem )
{
	_DrawFileName(pGraphics, pRcPS, pFileItem->strShowName, &pFileItem->rtName);

	double fPctProgress = ((double)pFileItem->dwCurSendSize * 100) / (double)pFileItem->dwTotalSize;
	_DrawProgressBar(pGraphics, fPctProgress, pFileItem->eStatus, &pFileItem->rtProgress);

	_DrawFileSize(pGraphics, pRcPS, pFileItem->strSize, &pFileItem->rtSize);

	_DrawCancelButton(pGraphics, pRcPS, &pFileItem->rtImgCancel);
}


void CMemoSendAttachList::_DrawFileName( Graphics* pGraphics, CRect *pRcPS,
										CString strFileName, CRect *pRcName )
{
	if (!(strFileName.IsEmpty()))
	{
		DrawTextToDest2(pGraphics,
			strFileName, pRcPS, pRcName,
			DEF_MEMOSEND_LIST_FONT_NAME, DEF_MEMOSEND_LIST_FILE_FONT_HEIGHT,
			StringAlignmentNear,
			DEF_MEMOSEND_LIST_FILE_FONT_STYLE,
			DEF_MEMOSEND_LIST_FILE_FONT_COLOR);
	}
}

void CMemoSendAttachList::_DrawProgressBar( Graphics* pGraphics, double dbProgress, 
										   EMEMOSEND_FILE_STATUS eStatus,
										   CRect *pRcProgress)
{
	if(m_pImgProgressBG[0] == NULL || m_pImgProgressBG[1] == NULL ||
		m_pImgProgressBG[2] == NULL || m_pImgProgressFG == NULL)
	{
		return;
	}

	InterpolationMode interpolationMode = pGraphics->GetInterpolationMode();
	PixelOffsetMode pixelOffsetMode = pGraphics->GetPixelOffsetMode();
	pGraphics->SetInterpolationMode(InterpolationModeNearestNeighbor);
	pGraphics->SetPixelOffsetMode(PixelOffsetModeHalf);

	//draw background
	pGraphics->DrawImage(m_pImgProgressBG[0], pRcProgress->left, pRcProgress->top,
		m_pImgProgressBG[0]->GetWidth(), m_pImgProgressBG[0]->GetHeight());

	pGraphics->DrawImage(m_pImgProgressBG[1], pRcProgress->left + m_pImgProgressBG[0]->GetWidth(),
		pRcProgress->top, pRcProgress->Width() - m_pImgProgressBG[2]->GetWidth(), m_pImgProgressBG[1]->GetHeight());

	pGraphics->DrawImage(m_pImgProgressBG[2], pRcProgress->right - m_pImgProgressBG[2]->GetWidth(),
		pRcProgress->top, m_pImgProgressBG[2]->GetWidth(), m_pImgProgressBG[2]->GetHeight());

	//draw progress
	if(eStatus == EMEMOSEND_COMPLETE || eStatus == EMEMOSEND_FORWARD)
	{
		pGraphics->DrawImage(m_pImgProgressFG, pRcProgress->left, pRcProgress->top,
			pRcProgress->Width(), m_pImgProgressFG->GetHeight());
	}
	else
	{
		LONG lWidth = (LONG)pRcProgress->Width() * dbProgress / 100;
		pGraphics->DrawImage(m_pImgProgressFG, pRcProgress->left, pRcProgress->top,
			lWidth, m_pImgProgressFG->GetHeight());
	}


	pGraphics->SetInterpolationMode(interpolationMode);
	pGraphics->SetPixelOffsetMode(pixelOffsetMode);

}

void CMemoSendAttachList::_DrawFileSize( Graphics* pGraphics, CRect *pRcPS,
										CString strSize, CRect* pRcSize)
{
	if (!(strSize.IsEmpty()))
	{
		DrawTextToDest2(pGraphics,
			strSize, pRcPS, pRcSize,
			DEF_MEMOSEND_LIST_FONT_NAME, DEF_MEMOSEND_LIST_FILE_FONT_HEIGHT,
			StringAlignmentFar,
			DEF_MEMOSEND_LIST_FILE_FONT_STYLE,
			DEF_MEMOSEND_LIST_FILE_FONT_COLOR);
	}
}

void CMemoSendAttachList::_DrawCancelButton( Graphics* pGraphics, CRect *pRcPS, CRect* pRcCancel )
{
	ImageAttributes ImgAttr;
	if (m_pImgCancel != NULL)
	{
		DrawImageToDest(pGraphics, m_pImgCancel, pRcPS, pRcCancel, &ImgAttr);
		pGraphics->DrawImage(m_pImgCancel, pRcCancel->left, pRcCancel->top,
			pRcCancel->Width(), pRcCancel->Height());
	}
}

